byte b[]; 
int parcoureur=0;
int vitesse = 300; // la vitesse entre deux beat en millieme de secondes

int trigger;
float vol = 0.45;
String[] notes= {
  "E2", "F2", "G2", "A3", "B3", 
  "C3", "D3", "E3", "F3", "G3", 
  "A3", "B3", "C4", "D4", "E4", 
  "F4", "G4", "A5", "B5", "C5", 
  "D5", "E5", "F5", "G5", "A6"};


// import everything necessary to make sound.
import ddf.minim.*;
import ddf.minim.ugens.*;

Minim minim;
AudioOutput out;

void setup() {
  // initialize the drawing window
  size(512, 400);
  b = loadBytes("texte.txt");

  // initialize the minim and out objects
  minim = new Minim(this);
  out   = minim.getLineOut();
  // placer le tempo : minute/  300.0f 
  out.setTempo( (1000/vitesse)*60.0 );
  // set a percentage for the actual duration
  out.setDurationFactor( 0.95f );
}

// draw is run many times
void draw() {

  if (millis() > trigger) {
    background( 64, 32, 0 );
    int a = b[parcoureur] & 0xff;  // Print each value, from 0 to 255 
    print(char(a));
    if (char(a)=='.') {
      println("point");
    }
    Waveform disWave = Waves.sawh( 4 );
    
    // on utilise modulo pour choisir dans les notes
    int n=a % notes.length;
    out.playNote( 0.0, 1.0, new ToneInstrument( notes[n], vol, disWave, out ) );

    parcoureur++;
    if (parcoureur >= b.length) {
      parcoureur=0;
      println("boucle");
    }
    fill(255);
    text(char(a), width/2, 100);
    // draw the waveforms
    trigger = millis() + vitesse;
  }

  // draw using a beige stroke
  stroke( 255, 238, 192 );

  for ( int i = 0; i < out.bufferSize() - 1; i++ ) {
    // find the x position of each buffer value
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    // draw a line from one buffer position to the next for both channels
    line( x1, 250 + out.left.get(i)*50, x2, 250 + out.left.get(i+1)*50);
    line( x1, 350 + out.right.get(i)*50, x2, 350 + out.right.get(i+1)*50);
  }
}